Index: trunk/user-apps/Grr/Components/ArticleOperations/GNUmakefile
===================================================================
--- trunk/user-apps/Grr/Components/ArticleOperations/GNUmakefile	(revision 3909)
+++ trunk/user-apps/Grr/Components/ArticleOperations/GNUmakefile	(working copy)
@@ -23,7 +23,8 @@
 
 ADDITIONAL_OBJCFLAGS = -Wall -Wno-import
 
-ADDITIONAL_INCLUDE_DIRS += -I../..
+ADDITIONAL_INCLUDE_DIRS += -I../.. -I../../../../libs
+ADDITIONAL_LIB_DIRS += -L../../../../libs/RSSKit/RSSKit.framework
 
 include ../../GNUmakefile.preamble
 
Index: trunk/user-apps/Grr/Components/ArticleView/GNUmakefile
===================================================================
--- trunk/user-apps/Grr/Components/ArticleView/GNUmakefile	(revision 3909)
+++ trunk/user-apps/Grr/Components/ArticleView/GNUmakefile	(working copy)
@@ -26,7 +26,8 @@
 
 ADDITIONAL_OBJCFLAGS = -Wall -Wno-import
 
-ADDITIONAL_INCLUDE_DIRS += -I../..
+ADDITIONAL_INCLUDE_DIRS += -I../.. -I../../../../libs
+ADDITIONAL_LIB_DIRS += -L../../../../libs/RSSKit/RSSKit.framework
 
 include ../../GNUmakefile.preamble
 
Index: trunk/user-apps/Grr/Components/DatabaseOperations/GNUmakefile
===================================================================
--- trunk/user-apps/Grr/Components/DatabaseOperations/GNUmakefile	(revision 3909)
+++ trunk/user-apps/Grr/Components/DatabaseOperations/GNUmakefile	(working copy)
@@ -23,7 +23,8 @@
 
 ADDITIONAL_OBJCFLAGS = -Wall -Wno-import
 
-ADDITIONAL_INCLUDE_DIRS += -I../..
+ADDITIONAL_INCLUDE_DIRS += -I../.. -I../../../../libs
+ADDITIONAL_LIB_DIRS += -L../../../../libs/RSSKit/RSSKit.framework
 
 include ../../GNUmakefile.preamble
 
Index: trunk/user-apps/Grr/Components/DatabaseTreeView/GNUmakefile
===================================================================
--- trunk/user-apps/Grr/Components/DatabaseTreeView/GNUmakefile	(revision 3909)
+++ trunk/user-apps/Grr/Components/DatabaseTreeView/GNUmakefile	(working copy)
@@ -23,7 +23,8 @@
 
 ADDITIONAL_OBJCFLAGS = -Wall -Wno-import
 
-ADDITIONAL_INCLUDE_DIRS += -I../..
+ADDITIONAL_INCLUDE_DIRS += -I../.. -I../../../../libs
+ADDITIONAL_LIB_DIRS += -L../../../../libs/RSSKit/RSSKit.framework
 
 include ../../GNUmakefile.preamble
 
Index: trunk/user-apps/Grr/Components/Searching/GNUmakefile
===================================================================
--- trunk/user-apps/Grr/Components/Searching/GNUmakefile	(revision 3909)
+++ trunk/user-apps/Grr/Components/Searching/GNUmakefile	(working copy)
@@ -27,7 +27,8 @@
 
 ADDITIONAL_OBJCFLAGS = -Wall -Wno-import
 
-ADDITIONAL_INCLUDE_DIRS += -I../..
+ADDITIONAL_INCLUDE_DIRS += -I../.. -I../../../../libs
+ADDITIONAL_LIB_DIRS += -L../../../../libs/RSSKit/RSSKit.framework
 
 include ../../GNUmakefile.preamble
 
Index: trunk/user-apps/Grr/Components/SubscriptionPanel/GNUmakefile
===================================================================
--- trunk/user-apps/Grr/Components/SubscriptionPanel/GNUmakefile	(revision 3909)
+++ trunk/user-apps/Grr/Components/SubscriptionPanel/GNUmakefile	(working copy)
@@ -24,7 +24,8 @@
 
 ADDITIONAL_OBJCFLAGS = -Wall -Wno-import
 
-ADDITIONAL_INCLUDE_DIRS += -I../..
+ADDITIONAL_INCLUDE_DIRS += -I../.. -I../../../../libs
+ADDITIONAL_LIB_DIRS += -L../../../../libs/RSSKit/RSSKit.framework
 
 include ../../GNUmakefile.preamble
 
Index: trunk/user-apps/Grr/Components/TreeDatabase/GNUmakefile
===================================================================
--- trunk/user-apps/Grr/Components/TreeDatabase/GNUmakefile	(revision 3909)
+++ trunk/user-apps/Grr/Components/TreeDatabase/GNUmakefile	(working copy)
@@ -18,7 +18,8 @@
 
 ADDITIONAL_OBJCFLAGS = -Wall -Wno-import
 
-ADDITIONAL_INCLUDE_DIRS += -I../..
+ADDITIONAL_INCLUDE_DIRS += -I../.. -I../../../../libs
+ADDITIONAL_LIB_DIRS += -L../../../../libs/RSSKit/RSSKit.framework
 
 include ../../GNUmakefile.preamble
 
Index: trunk/user-apps/Grr/GNUmakefile.preamble
===================================================================
--- trunk/user-apps/Grr/GNUmakefile.preamble	(revision 3909)
+++ trunk/user-apps/Grr/GNUmakefile.preamble	(working copy)
@@ -1,5 +1,5 @@
 # Preamble Definitions
-ADDITIONAL_INCLUDE_DIRS += -I../../libs/RSSKit/
+ADDITIONAL_INCLUDE_DIRS += -I../../libs/
 ADDITIONAL_LIB_DIRS += -L../../libs/RSSKit/RSSKit.framework/
 ADDITIONAL_GUI_LIBS += -lRSSKit
 
Index: trunk/user-apps/TalkSoup/InFilters/DCCSupport/DCCObject.h
===================================================================
--- trunk/user-apps/TalkSoup/InFilters/DCCSupport/DCCObject.h	(revision 3909)
+++ trunk/user-apps/TalkSoup/InFilters/DCCSupport/DCCObject.h	(working copy)
@@ -48,8 +48,8 @@
 @end
 
 #import <Foundation/NSObject.h>
-#import <netclasses/NetBase.h>
-#import <netclasses/NetTCP.h>
+#import <netclasses/Source/NetBase.h>
+#import <netclasses/Source/NetTCP.h>
 
 #include <stdint.h>
 
Index: trunk/user-apps/TalkSoup/InFilters/DCCSupport/DCCSupport.m
===================================================================
--- trunk/user-apps/TalkSoup/InFilters/DCCSupport/DCCSupport.m	(revision 3909)
+++ trunk/user-apps/TalkSoup/InFilters/DCCSupport/DCCSupport.m	(working copy)
@@ -17,7 +17,7 @@
  ***************************************************************************/
 
 #import <TalkSoupBundles/TalkSoup.h>
-#import <netclasses/NetTCP.h>
+#import <netclasses/Source/NetTCP.h>
 #import "DCCObject.h"
 #import "DCCSupport.h"
 #import "DCCSender.h"
Index: trunk/user-apps/TalkSoup/InFilters/DCCSupport/GNUmakefile.preamble
===================================================================
--- trunk/user-apps/TalkSoup/InFilters/DCCSupport/GNUmakefile.preamble	(revision 3909)
+++ trunk/user-apps/TalkSoup/InFilters/DCCSupport/GNUmakefile.preamble	(working copy)
@@ -1,5 +1,5 @@
 
-ADDITIONAL_INCLUDE_DIRS += -I. -I../..
+ADDITIONAL_INCLUDE_DIRS += -I. -I../.. -I../../../../libs/
 
 ADDITIONAL_OBJCFLAGS += -Wall -Wno-protocol
 
@@ -11,5 +11,5 @@
 ADDITIONAL_OBJCFLAGS += -I../../Misc -include GNUstep.h $(ADDITIONAL_FRAMEWORK_DIRS) -F../../TalkSoupBundles
 ADDITIONAL_LDFLAGS += -F../../TalkSoupBundles
 else
-ADDITIONAL_LDFLAGS += -L../../TalkSoupBundles/TalkSoupBundles.framework/Versions/Current
+ADDITIONAL_LDFLAGS += -L../../TalkSoupBundles/TalkSoupBundles.framework/Versions/Current -L../.. -L../../../../libs/netclasses/Source/netclasses.framework
 endif
Index: trunk/user-apps/TalkSoup/Input/NetclassesInput/GNUmakefile.preamble
===================================================================
--- trunk/user-apps/TalkSoup/Input/NetclassesInput/GNUmakefile.preamble	(revision 3909)
+++ trunk/user-apps/TalkSoup/Input/NetclassesInput/GNUmakefile.preamble	(working copy)
@@ -1,4 +1,4 @@
-ADDITIONAL_INCLUDE_DIRS += -I. -I../..
+ADDITIONAL_INCLUDE_DIRS += -I. -I../.. -I../../../../libs
 
 ADDITIONAL_OBJCFLAGS += -Wall -Wno-protocol
 
@@ -6,6 +6,6 @@
 ADDITIONAL_OBJCFLAGS += -F../../TalkSoupBundles -I../../Misc -include GNUstep.h $(ADDITIONAL_FRAMEWORK_DIRS)
 ADDITIONAL_LDFLAGS += -F../../TalkSoupBundles
 else
-ADDITIONAL_LDFLAGS += -L../../TalkSoupBundles/TalkSoupBundles.framework/Versions/Current
+ADDITIONAL_LDFLAGS += -L../../TalkSoupBundles/TalkSoupBundles.framework/Versions/Current -L../../../../libs/netclasses/Source/netclasses.framework
 endif
 
Index: trunk/user-apps/TalkSoup/Input/NetclassesInput/NetclassesInputSendThenDieTransport.h
===================================================================
--- trunk/user-apps/TalkSoup/Input/NetclassesInput/NetclassesInputSendThenDieTransport.h	(revision 3909)
+++ trunk/user-apps/TalkSoup/Input/NetclassesInput/NetclassesInputSendThenDieTransport.h	(working copy)
@@ -17,7 +17,7 @@
 
 @class NetclassesInputSendThenDieTransport;
 
-#import <netclasses/NetBase.h>
+#import <netclasses/Source/NetBase.h>
 
 @class NSData;
 
Index: trunk/user-apps/TalkSoup/Input/NetclassesInput/main.h
===================================================================
--- trunk/user-apps/TalkSoup/Input/NetclassesInput/main.h	(revision 3909)
+++ trunk/user-apps/TalkSoup/Input/NetclassesInput/main.h	(working copy)
@@ -16,7 +16,7 @@
  *                                                                         *
  ***************************************************************************/
 
-#import <netclasses/IRCObject.h>
+#import <netclasses/Source/IRCObject.h>
 #import <TalkSoupBundles/TalkSoup.h>
 
 #import <Foundation/NSObject.h>